"""
Copyright (c) 2019, Swiss Federal Institute of Technology (ETH Zurich)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the copyright holder nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

"""

import numpy as np

def cal_Energy_Band_Mat(N, N_bins, Fs):
    weights = np.zeros((N_bins, N//2))
    freq_bins = np.linspace(0, Fs//2, N//2, endpoint=True)     # Center freqs of each FFT bin

    '''
    f_scaler = (1 / 8)
    f_lin = (Fs / 2) * f_scaler  # frequency limit for linear spacing
    n_scaler = 0.5
    n_lin = int((N_bins + 2) * n_scaler)
    freqs_lin = np.linspace(0, f_lin, n_lin, endpoint=False)
    freqs_log = np.logspace(np.log10(f_lin), np.log10(Fs / 2), int(N_bins + 2) - n_lin, endpoint=True)
    freqs = np.concatenate((freqs_lin,freqs_log),axis=0)                                # 1. Combination: lin log
    '''
    # freqs = np.logspace(0, np.log10(Fs / 2), int(N_bins+2), endpoint=True)            # 2. logarithm: has some issues, NaN values in low frequency bands
    freqs = np.linspace(0, Fs / 2, int(N_bins + 2), endpoint=True)                      # 3. linear

    for i in range(N_bins):
        # lower and upper slopes for all bins
        lower = (freq_bins - freqs[i]) / (freqs[i + 1] - freqs[i])
        upper = (freqs[i + 2] - freq_bins) / (freqs[i + 2] - freqs[i + 1])

        weights[i] = np.maximum(0, np.minimum(lower, upper))
        weights[i] = weights[i] / np.sum(weights[i])

    return weights


# weights = cal_Energy_Band_Mat(1024,32,1000)
import librosa
weights = librosa.filters.mel(1000, 1024, n_mels=64,fmin=2,fmax=250)
print(np.sum(weights==0,axis=1))
print(np.sum(weights!=0,axis=1))

from aednn.datasets.MHdataset import microseismic_dataset
dataset = microseismic_dataset('tmp/',name='none',params={'dataframe':{'microseismic_labels':'none'},'datadir':0},transform_type='custom_melspec')


np.savetxt('tmp/weights.txt',weights,fmt='%2.5f')

def main():
    # ----- Setting initial variable
    N = 1024  # Length of FFT
    N_bins = 64  # how many freq_bins we want to have
    Fs = 1000.0  # Sample frequency

    # ----- Compute Matrix for Energy band
    w_mat = cal_Energy_Band_Mat(N, N_bins, Fs)
    mel_basis = dataset.mel_transform()[:,:512]

    print(w_mat.shape,mel_basis.shape)
    w_mat = mel_basis
    # print(np.sum(w_mat,axis=0),np.sum(w_mat,axis=1))

    print('Energy Band Weight Matrix = \n' + str(w_mat))
    print('The Shape of Energy Band Weight Matrix = ' + str(w_mat.shape))

    np.savetxt('tmp/w_mat.h', [], delimiter='', newline='\n',
               header= '/* Weight matrix for energy band, automatically generated by fft_analysis.py */\n'
                       + '#include "arm_math.h"\n\n'
                       + '// Sample Frequency ' + str(Fs) + '\n\n'
                       + '#define FFT_NUM_BINS ' + str(N_bins) + '\n'
                       + 'const float32_t weight_mat[' + str(N_bins) + '*' + str(N // 2) + '];\n', comments='')
    np.savetxt('tmp/w_mat.c', w_mat.transpose().reshape(1, N_bins*N//2), fmt='%2.10f', delimiter=', ', newline='\n',
               header= '/* Weight matrix for energy band, automatically generated by fft_analysis.py */\n'
                       + '#include "arm_math.h"\n\n'
                       + '// Sample Frequency ' + str(Fs) + '\n\n'
                       + '#define FFT_LENGTH ' + str(N) + '\n\n'
                       + 'const float32_t weight_mat[' + str(N_bins) + '*' + str(N // 2) + '] = \n'
                       + '{',
               footer='};', comments='')
    
    window = dataset.window().reshape((1,-1))
    np.savetxt('tmp/fft_window.h', [], delimiter='', newline='\n',
               header= '/* FFT Window (automatically generated) */\n'
                       + '#include "arm_math.h"\n\n'
                       + '// FFT_LENGTH ' + str(N) + '\n\n'
                       + 'const float32_t fft_scale;\n\n'
                       + 'const float32_t fft_window[' + str(window.size) + '];\n', comments='')
    np.savetxt('tmp/fft_window.c', window, fmt='%2.10f', delimiter=', ', newline='\n',
               header= '/* FFT Window (automatically generated) */\n'
                       + '#include "arm_math.h"\n\n'
                       + '// FFT_LENGTH ' + str(N) + '\n\n'
                       + 'const float32_t fft_scale = ' + str(1/window.sum()**2) + ';\n\n'
                       + 'const float32_t fft_window[' + str(window.size) + '] = \n'
                       + '{',
               footer='};', comments='')

if __name__ == "__main__":
    main()